hud.add(function(v, player, cam)
	if not player.spinDamage.displayTimer then return end
	
	local bar = v.cachePatch("SPINBAR")
	local p = v.cachePatch("SPINBARP")
	local e = v.cachePatch("SPINBARE")
	local spincolor = v.getColormap("sonic", player.mo.color)
	local barcolor = spincolor
	local redFlag = 0
	if player.spinDamage.percent < 20
	and leveltime % 2 == 0
		if player.mo.color == SKINCOLOR_RED
			barcolor = v.getColormap("sonic", SKINCOLOR_WHITE)
		else
			barcolor = v.getColormap("sonic", SKINCOLOR_RED)
		end
		redFlag = V_REDMAP
	end
	
	v.draw(190, 176, bar, v.localTransFlag()|V_SNAPTORIGHT|V_SNAPTOBOTTOM, spincolor)
	if player.spinDamage.percent > 0
		v.draw(215, 190, e, v.localTransFlag()|V_SNAPTORIGHT|V_SNAPTOBOTTOM, barcolor)
	end
	if player.spinDamage.percent > 3
		v.drawStretched(216*FRACUNIT, 190*FRACUNIT, (player.spinDamage.percent-2)*FRACUNIT, FRACUNIT, p, v.localTransFlag()|V_SNAPTORIGHT|V_SNAPTOBOTTOM, barcolor)
	end
	if player.spinDamage.percent > 1
		v.draw((214+player.spinDamage.percent), 190, e, v.localTransFlag()|V_SNAPTORIGHT|V_SNAPTOBOTTOM, barcolor)
	end
	v.drawString(217, 178, player.spinDamage.percent.."%", v.localTransFlag()|V_SNAPTORIGHT|V_SNAPTOBOTTOM|redFlag)
end, "game")