addHook("PlayerSpawn", function(player)
	player.spinDamage = {
		percent = 100,
		timer = 0,
		resetTimer = false,
		displayTimer = 0
	}
end)

addHook("PlayerThink", function(player)
	if player.spinDamage.percent == 0 then
		P_DamageMobj(player.mo)
		S_StartSound(player.mo, sfx_skid)
		player.spinDamage.displayTimer = 0
		player.spinDamage.percent = 100
	end
	
	if player.spinDamage.percent < 100
		player.spinDamage.displayTimer = 3*TICRATE
	elseif player.spinDamage.displayTimer > 0
		player.spinDamage.displayTimer = $-1
	end
	
	if not player.powers[pw_invulnerability]
	and not player.powers[pw_flashing]
	and player.pflags & PF_SPINNING
	and P_IsObjectOnGround(player.mo)
	and player.spinDamage.percent > 0
		if player.mo.state == S_PLAY_SPINDASH
			if player.spinDamage.timer >= 4
				player.spinDamage.timer = 0
				player.spinDamage.percent = $-1
				player.spinDamage.resetTimer = true
			end
			player.spinDamage.timer = $+1
		else
			if player.spinDamage.timer >= 8
				player.spinDamage.timer = 0
				player.spinDamage.percent = $-1
				player.spinDamage.resetTimer = true
			end
			player.spinDamage.timer = $+1
		end
	else
		if player.spinDamage.percent < 100
		and leveltime % 35 == 0
		and player.spinDamage.timer >= 105
			player.spinDamage.percent = $+1
		end
		
		if player.spinDamage.timer < 105
			player.spinDamage.timer = $+1
		end
		
		if player.spinDamage.resetTimer == true
			player.spinDamage.timer = 0
			player.spinDamage.resetTimer = false
		end
	end
end)